function configLoadL4DItems(%file)
{
	%read = new FileObject();
	if(!isFile("config/server/L4DSurvivor/" @ %file @ ".txt"))
	{
		%read.openForRead("Add-Ons/Player_L4DSurvivor/" @ %file @ ".txt");
		
		%write = new FileObject();
		%write.openForWrite("config/server/L4DSurvivor/" @ %file @ ".txt");
		
		while(!%read.isEOF())
		{
			%line = %read.readLine();
			%write.writeLine(%line);
		}
		
		%read.close();
		
		%write.close();
		%write.delete();
	}
	
	%read.openForRead("config/server/L4DSurvivor/" @ %file @ ".txt");
	
	while(!%read.isEOF())
	{
		%line = %read.readLine();
		if(%line !$= "")
			%type[%line]   = %file;
	}
	
	%read.close();
	%read.delete();
	
	for(%i=0;%i<dataBlockGroup.getCount();%i++)
	{
		%o = dataBlockGroup.getObject(%i);
		if(%o.getClassName() !$= "ItemData")
			continue;
		if(%o.uiName $= "")
			continue;
		
		if(%type[%o.uiName] !$= "")
			%o.l4ditemtype = %type[%o.uiName];
	}
}

function configLoadDualWield()
{
	%read = new FileObject();
	if(!isFile("config/server/L4DSurvivor/duals.txt"))
	{
		%read.openForRead("Add-Ons/Player_L4DSurvivor/duals.txt");
		
		%write = new FileObject();
		%write.openForWrite("config/server/L4DSurvivor/duals.txt");
		
		while(!%read.isEOF())
		{
			%line = %read.readLine();
			%write.writeLine(%line);
		}
		
		%read.close();
		
		%write.close();
		%write.delete();
	}
	
	%read.openForRead("config/server/L4DSurvivor/duals.txt");
	
	while(!%read.isEOF())
	{
		%line = %read.readLine();
		if(%line !$= "")
		{
			%single = getField(%line,0);
			%dual   = getField(%line,1);
			%single[%dual] = %single;
			%dual[%single] = %dual;
		}
	}
	
	%read.close();
	%read.delete();
	
	for(%i=0;%i<dataBlockGroup.getCount();%i++)
	{
		%o = dataBlockGroup.getObject(%i);
		if(%o.getClassName() !$= "ItemData")
			continue;
		if(%o.uiName $= "")
			continue;
		
		%name = %o.uiName;
		%dual = (%dual[%name]);
		%single = (%single[%name]);
		
		if(%single !$= "")
		{
			//This weapon is the dual of another
			if(isObject(%singleID[%single]))
				%singleID[%single].l4ddualgun = %o;
			
			%dualID[%name] = %o;
		}
		else if(%dual !$= "")
		{
			//This weapon is the single version of another
			if(isObject(%dualID[%name]))
				%o.l4ddualgun = %dualID[%name];
			
			%singleID[%name] = %o;
		}
	}
}

function configLoadAllL4DItems()
{
	configLoadL4DItems("secondary");
	configLoadL4DItems("grenade");
	configLoadL4DItems("heal_pill");
	configLoadL4DItems("heal_full");
	//configLoadL4DItems("special");
	
	configLoadDualWield();
}
schedule(1000,0,configLoadAllL4DItems);

package L4DItems
{
	function ItemData::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(%col.dataBlock.usesL4DItems && %col.getDamagePercent() < 100 && %obj.canPickup && (isObject(%this.l4ddualgun) || %item.dataBlock.l4ditemtype $= "special"))
		{
			return %col.pickup(%obj);
		}
		return Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}
	
	function Player::pickup(%player,%item)
	{
		if(!%player.dataBlock.usesL4DItems)
			return Parent::pickup(%player,%item);
		
		if(!isObject(%item))
			return 0;
		
		if(miniGameCanUse(%player,%item) == 0)
			return Parent::pickup(%player,%item);
		
		if(!%item.canPickup)
			return 0;
		
		switch$(%item.dataBlock.l4ditemtype)
		{
			case "special":
				%numList = -1;
				%all = 1;
				%alldata = %player.tool[2];
				for(%i=2;%i<%player.dataBlock.maxTools;%i++)
				{
					%t = %player.tool[%i];
					if(%t != 0)
					{
						%list[%numList++] = %t.uiName;
						if(%t.getID() != %alldata)
							%all = 0;
						continue;
					}
					
					%player.tool[%i] = %item.dataBlock.getID();
					messageClient(%player.client,'MsgItemPickup','',%i,%item.dataBlock.getID());
					if(%item.static)
						%item.respawn();
					else
						%item.delete();
					return 1;	
				}
				
				if(isObject(%player.client))
				{
					%msg1 = "\c5You have no more room for \c3special items\c5!";
					if(%all)
					{
						%msg2 = "\c5Drop a \c3" @ %alldata.uiName;
					}
					else
					{
						%msg2 = "\c5Drop your \c3" @ %list[0];
						if(%numList > 0)
						{
							for(%i=1;%i<%numList;%i++)
								%msg2 = %msg2 @ "\c5, \c3" @ %list[%i];
							%msg2 = %msg2 @ "\c5 or \c3" @ %list[%numList];
						}
					}
					%msg2 = %msg2 @ "\c5 to pick this up.";
					%player.client.centerPrint(%msg1 NL %msg2,1);
				}
				
				return 0;
			
			case "secondary":
				%slot = 1;
				if(%player.tool[%slot] == 0)
				{
					%player.tool[%slot] = %item.dataBlock.getID();
					messageClient(%player.client,'MsgItemPickup','',%slot,%item.dataBlock.getID());
					if(%item.static)
						%item.respawn();
					else
						%item.delete();
					
					return 1;
				}
				else if(%player.tool[%slot] == %item.dataBlock.getID() && isObject(%player.tool[%slot].l4ddualgun))
				{
					%player.tool[%slot] = %player.tool[%slot].l4ddualgun;
					messageClient(%player.client,'MsgItemPickup','',%slot,%player.tool[%slot].getID());
					if(%item.static)
						%item.respawn();
					else
						%item.delete();
					
					return 1;
				}
				else
				{
					if(isObject(%player.client))
					{
						%msg1 = "\c5You already have a \c3secondary weapon\c5!";
						%msg2 = "\c5Drop your \c3" @ %player.tool[%slot].uiName @ "\c5 to pick this up.";
						%player.client.centerPrint(%msg1 NL %msg2,1);
					}
					return 0;
				}
			
			case "grenade":
				%slot = 2;
				if(%player.tool[%slot] == 0)
				{
					%player.tool[%slot] = %item.dataBlock.getID();
					messageClient(%player.client,'MsgItemPickup','',%slot,%item.dataBlock.getID());
					if(%item.static)
						%item.respawn();
					else
						%item.delete();
					
					return 1;
				}
				else if(%player.tool[%slot] == %item.dataBlock.getID() && isObject(%player.tool[%slot].l4ddualgun))
				{
					%player.tool[%slot] = %player.tool[%slot].l4ddualgun;
					messageClient(%player.client,'MsgItemPickup','',%slot,%player.tool[%slot].getID());
					if(%item.static)
						%item.respawn();
					else
						%item.delete();
					
					return 1;
				}
				else
				{
					if(isObject(%player.client))
					{
						%msg1 = "\c5You already have a \c3grenade\c5 weapon!";
						%msg2 = "\c5Drop your \c3" @ %player.tool[%slot].uiName @ "\c5 to pick this up.";
						%player.client.centerPrint(%msg1 NL %msg2,1);
					}
					return 0;
				}
			
			case "heal_full":
				%slot = 3;
				if(%player.tool[%slot] == 0)
				{
					%player.tool[%slot] = %item.dataBlock.getID();
					messageClient(%player.client,'MsgItemPickup','',%slot,%item.dataBlock.getID());
					if(%item.static)
						%item.respawn();
					else
						%item.delete();
					
					return 1;
				}
				else if(%player.tool[%slot] == %item.dataBlock.getID() && isObject(%player.tool[%slot].l4ddualgun))
				{
					%player.tool[%slot] = %player.tool[%slot].l4ddualgun;
					messageClient(%player.client,'MsgItemPickup','',%slot,%player.tool[%slot].getID());
					if(%item.static)
						%item.respawn();
					else
						%item.delete();
					
					return 1;
				}
				else
				{
					if(isObject(%player.client))
					{
						%msg1 = "\c5You already have a \c3secondary healing\c5 item!";
						%msg2 = "\c5Drop your \c3" @ %player.tool[%slot].uiName @ "\c5 to pick this up.";
						%player.client.centerPrint(%msg1 NL %msg2,1);
					}
					return 0;
				}
			
			case "heal_pill":
				%slot = 4;
				if(%player.tool[%slot] == 0)
				{
					%player.tool[%slot] = %item.dataBlock.getID();
					messageClient(%player.client,'MsgItemPickup','',%slot,%item.dataBlock.getID());
					if(%item.static)
						%item.respawn();
					else
						%item.delete();
					
					return 1;
				}
				else if(%player.tool[%slot] == %item.dataBlock.getID() && isObject(%player.tool[%slot].l4ddualgun))
				{
					%player.tool[%slot] = %player.tool[%slot].l4ddualgun;
					messageClient(%player.client,'MsgItemPickup','',%slot,%player.tool[%slot].getID());
					if(%item.static)
						%item.respawn();
					else
						%item.delete();
					
					return 1;
				}
				else
				{
					if(isObject(%player.client))
					{
						%msg1 = "\c5You already have a \c3secondary healing\c5 item!";
						%msg2 = "\c5Drop your \c3" @ %player.tool[%slot].uiName @ "\c5 to pick this up.";
						%player.client.centerPrint(%msg1 NL %msg2,1);
					}
					return 0;
				}
			
			default:
				%slot = 0;
				if(%player.tool[%slot] == 0)
				{
					%player.tool[%slot] = %item.dataBlock.getID();
					messageClient(%player.client,'MsgItemPickup','',%slot,%item.dataBlock.getID());
					if(%item.static)
						%item.respawn();
					else
						%item.delete();
					
					return 1;
				}
				else if(%player.tool[%slot] == %item.dataBlock.getID() && isObject(%player.tool[%slot].l4ddualgun))
				{
					%player.tool[%slot] = %player.tool[%slot].l4ddualgun;
					messageClient(%player.client,'MsgItemPickup','',%slot,%player.tool[%slot].getID());
					if(%item.static)
						%item.respawn();
					else
						%item.delete();
					
					return 1;
				}
				else
				{
					if(isObject(%player.client))
					{
						%msg1 = "\c5You already have a \c3primary weapon\c5!";
						%msg2 = "\c5Drop your \c3" @ %player.tool[%slot].uiName @ "\c5 to pick this up.";
						%player.client.centerPrint(%msg1 NL %msg2,1);
					}
					return 0;
				}
		}
		
	}
};activatePackage(L4DItems);